//+------------------------------------------------------------------+
//|                                                  Guppy delta.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+




#property copyright "brax64 - forexTSD"


#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 White
#property indicator_color2 DimGray
#property indicator_color3 Lime
#property indicator_color4 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2

extern bool show_Histo = false;

//---- buffers
double gmmadelta[];
double gmmaplus[];
double gmmmaminus[];
double gmmashort[];
double gmmalong[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexBuffer(0,gmmashort);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"short");
   SetIndexBuffer(1,gmmalong);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"long");
   SetIndexBuffer(2,gmmaplus);
   SetIndexLabel(2,NULL);
   SetIndexBuffer(3,gmmmaminus);
   SetIndexLabel(3,NULL);
   SetIndexBuffer(4,gmmadelta);
   SetIndexLabel(4,NULL);
   
   if(show_Histo)
   {
      SetIndexStyle(0,DRAW_NONE);
      SetIndexLabel(0,NULL);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexLabel(1,NULL);   
      SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexLabel(2,"delta +");
      SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexLabel(3,"delta -");
      SetIndexStyle(4,DRAW_NONE);
   }
   
//----
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
  {
   int i,limit,counted_bars=IndicatorCounted();
   
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   for(i=0; i<limit; i++)
   {
      
      gmmashort[i]=iMA(NULL,0,3,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,8,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,10,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,12,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,15,0,MODE_EMA,PRICE_CLOSE,i);
      
      gmmalong[i] =iMA(NULL,0,30,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,35,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,40,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,45,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,50,0,MODE_EMA,PRICE_CLOSE,i)+
                   iMA(NULL,0,60,0,MODE_EMA,PRICE_CLOSE,i);
      if(show_Histo)
      {
      
      gmmadelta[i] = (gmmashort[i] - gmmalong[i]) * 1000;
      
      if(gmmadelta[i] > 0) gmmaplus[i] = gmmadelta[i];
      else gmmmaminus[i] = gmmadelta[i];
      }
   }
   
   
      
   return(0);
  }
//+------------------------------------------------------------------+